package com.caimei365.manager.dao.svip;

import com.caimei365.manager.entity.caimei.CmUser;
import com.caimei365.manager.entity.caimei.MessageCenter;
import com.caimei365.manager.entity.caimei.product.Product;
import com.caimei365.manager.entity.caimei.svip.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2023/4/7
 */
@Mapper
public interface CmSvipHistoryDao {

    /**
     * 超级会员列表
     * @param vip
     * @return
     */
    List<CmSvipHistory> superFind(CmSvipHistory vip);

    /**
     * 获取状态
     * @param userId
     * @return
     */
    CmSvipHistory findEndTime(Long userId);

    /**
     * 机构信息
     * @param clubId
     * @param name
     * @param shortName
     * @return
     */
    List<CmUser> findUserList(@Param("clubId") Integer clubId, @Param("name") String name, @Param("shortName") String shortName);

    /**
     * 获取用户超级会员数据
     * @param userId
     * @return
     */
    CmSvipHistory findVipUser(String userId);

    /**
     * 添加消息
     * @param messageCenter
     */
    void addMessageCenter(MessageCenter messageCenter);

    void insertHistory(CmSvipHistory cmSvipHistory);

    void updateVip(CmSvipHistory cmSvipHistory);

    void giveVip(CmSvipHistory cmSvipHistory);

    /**
     * 获取购买记录
     * @param cmSvipHistory
     * @return
     */
    List<CmSvipHistory> findHistory(CmSvipHistory cmSvipHistory);

    /**
     * 状态
     * @param packageId
     * @return
     */
    Integer findDuration(Integer packageId);

    /**
     * 获取时间
     * @param id
     * @return
     */
    String findMonth(String id);

    CmVipCoupon vipCouponGet(String id);

    CmCoupon CmCouponGet(String id);

    NewCmShop newCmShopGet(String id);

    Integer findRedemptionCodeNum(String couponId);

    void updateByDelFlag(String couponId);

    void updateAssociateByDelFlag(String couponId);

    void updateVipCouponMonth(CmVipCoupon cmVipCoupon);

    void deleteByMonthId(String montId);

    List<Integer> findByCouponId(String couponId);

    void insertCouponAssociate(CmCouponAssociate associate);

    void updateCouponAssociate(CmCouponAssociate a);

    void logicDeleteCouponAssociate(Integer id);

    void insertCoupon(CmCoupon cmCoupon);

    void updateCoupon(CmCoupon cmCoupon);

    /**
     * 超级会员专属优惠券
     * @param cmVipCoupon
     * @return
     */
    List<CmVipCoupon> findCouponList(CmVipCoupon cmVipCoupon);

    List<String> getBindCoupons(String montId);

    List<CmCoupon> getCouponListByIds(@Param("bindCoupons") List<String> bindCoupons,@Param("couponType") String couponType,@Param("status") String status);

    /**
     * 供应商列表
     * @param newCmShop
     * @return
     */
    List<NewCmShop> findShopList(NewCmShop newCmShop);

    /**
     * 获取商品列表
     * @param product
     * @return
     */
    List<Product> findProductImage(Product product);
    /**
     * 超级会员优惠商品
     * @param svipProduct
     * @return
     */
    List<CmSvipProduct> findProductList(CmSvipProduct svipProduct);

    /**
     * 商品sku数据
     * @param productId
     * @return
     */
    CmSku findSku(Integer productId);

    /**
     * 商品sku
     * @param productId
     * @return
     */
    CmSku findSvipSku(Integer productId);

    /**
     * 套餐配置
     * @return
     */
    List<CmSvipPackage> findPackage();

    /**
     * 更新超级会员套餐信息
     * @param price
     * @param duration
     * @param proportion
     */
    void updatePrice(@Param("price") Double price, @Param("duration") Integer duration, @Param("proportion") Integer proportion);
}
