package com.caimei365.manager.entity.caimei.svip;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.util.Date;

/**
 * Description
 *
 * @author : Charles
 * @date : 2023/4/7
 */
@Data
public class CmSvipHistory {

    private String id;
    /**
     * 用户ID
     */
    private Long userId;
    /**
     * 超级会员套餐ID
     */
    private Integer packageId;
    /**
     * 生效时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date beginTime;
    /**
     * 到期时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date endTime;
    private String updateTime;
    /**
     * 用户付款方式：1线上，2线下，3余额抵扣，4采美豆抵扣
     */
    private String payWay;
    /**
     * 付款类型：1建设银行7297、2广发银行0115、3中信银行7172、4中信银行0897、5中信银行0897-财付通、6中信银行0897-支付宝、7线上-支付宝、8线上-微信支付、9线上-快钱支付、10口头返佣、11广发银行5461、12PC-B2B网银、13PC-微信支付、14PC-支付宝、15小程序-微信支付、16余额抵扣、17PC-B2C网银
     */
    private String payType;
    /**
     * 支付金额
     */
    private String price;
    /**
     * 抵扣采美豆数量
     */
    private String userBeans;
    /**
     * 购买时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date payTime;
    /**
     * jsp页面虚拟字段
     */
    private String status;
    /**
     * 赠送套餐的月份数
     */
    private String giveMonth;
    private String clubName;
    private String linkMan;
    private String mobile;
    private String startPayTime;
    private String endPayTime;
    private String startEndTime;
    private String endEndTime;
}
