package com.caimei365.manager.service;

import com.alibaba.fastjson.JSONObject;
import com.caimei.utils.HttpRequest;
import com.caimei.utils.StringUtils;
import com.caimei365.manager.config.thinkgem.Global;
import com.caimei365.manager.dao.newOrderDao;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Description
 *
 * @author : Charles
 * @date : 2023/4/10
 */
@Slf4j
@Service
public class SendSmsService {

    @Autowired private newOrderDao orderDao;

    public boolean getSendSms(int markId, String mobile, String content) throws Exception {
        String config = Global.getConfig("cm.config");
        //测试环境手机号允许发短信
        List<String> list = new ArrayList<>();
        list.add("15917362709");
        list.add("15814011616");
        list.add("13100721916");
        list.add("15113936829");
        list.add("18175515644");
        list.add("18476937515");
        if (config.equals("product") || list.contains(mobile)) {
            if (StringUtils.isNotBlank(mobile) && mobile.length() == 11) {
                String regex = "^(1[3-9]\\d{9}$)";
                Pattern pattern = Pattern.compile(regex);
                Matcher matcher = pattern.matcher(mobile);
                if (matcher.matches()) {
                    Map<String, Object> map = new HashMap<>(2);
                    map.put("content", content);
                    map.put("mobile", mobile);
                    String coreServer = Global.getConfig("caimei.core");
                    String url = coreServer + "/tools/sms/send";
                    String result = HttpRequest.sendPost(url, map);
                    JSONObject parseObject = JSONObject.parseObject(result);
                    Integer code = parseObject.getInteger("code");
                    if (code != 0) {
                        log.info("短信发送失败,手机号>>>>" + mobile);
                    } else {
                        orderDao.updateSendNum(markId, 1);
                        return true;
                    }
                }
            }
        }
        return false;
    }
}
