package com.caimei365.manager.service.caimei.svip;

import com.caimei365.manager.entity.PaginationVo;
import com.caimei365.manager.entity.ResponseJson;
import com.caimei365.manager.entity.caimei.CmUser;
import com.caimei365.manager.entity.caimei.product.Product;
import com.caimei365.manager.entity.caimei.svip.*;

/**
 * Description
 *
 * @author : Charles
 * @date : 2023/4/7
 */
public interface CmSvipHistoryService {

    /**
     * 超级会员列表
     * @param vip
     * @param pageNum
     * @param pageSize
     * @return
     */
    ResponseJson<PaginationVo<CmSvipHistory>> memberList(CmSvipHistory vip, Integer pageNum, Integer pageSize);

    /**
     * 获取机构信息
     * @param clubId
     * @param name
     * @param shortName
     * @param pageNum
     * @param pageSize
     * @return
     */
    ResponseJson<PaginationVo<CmUser>> findClubList(Integer clubId, String name, String shortName, Integer pageNum, Integer pageSize);

    /**
     * 赠送超级会员
     * @param cmSvipGive
     * @return
     */
    ResponseJson saveGive(CmSvipGive cmSvipGive) throws Exception ;

    /**
     * 获取购买记录
     * @param cmSvipHistory
     * @return
     */
    ResponseJson<PaginationVo<CmSvipHistory>> findHistory(CmSvipHistory cmSvipHistory, int pageNum, int pageSize);

    /**
     * 超级会员专属优惠券
     * @param cmVipCoupon
     * @param pageNum
     * @param pageSize
     * @return
     */
    ResponseJson<PaginationVo<CmVipCoupon>> couponList(CmVipCoupon cmVipCoupon, int pageNum, int pageSize);

    /**
     * 关闭超级会员专属优惠券
     * @param id
     * @return
     */
    ResponseJson closeCoupon(Integer id);

    /**
     * 开启超级会员专属优惠券
     * @param id
     * @return
     */
    ResponseJson openCoupon(Integer id);

    /**
     * 删除超级会员专属优惠券
     * @param id
     * @return
     */
    ResponseJson deleteCoupon(Integer id);

    /**
     * 获取供应商列表
     * @param cmShop
     * @return
     */
    ResponseJson<PaginationVo<NewCmShop>> findShopList(NewCmShop cmShop, int pageNum, int pageSize);

    /**
     * 获取商品列表
     * @param product
     * @param pageNum
     * @param pageSize
     * @return
     */
    ResponseJson<PaginationVo<Product>> findProductDialogList(Product product, int pageNum, int pageSize);

    /**
     *超级会员优惠商品
     * @param svipProduct
     * @param pageNum
     * @param pageSize
     * @return
     */
    ResponseJson<PaginationVo<CmSvipProduct>> findProductList(CmSvipProduct svipProduct, Integer pageNum, Integer pageSize);

    /**
     * 套餐配置
     * @return
     */
    ResponseJson<CmSvipPackage> findPackage();

    /**
     * 更新超级会员套餐信息
     * @param cmSvipPackage
     * @return
     */
    ResponseJson updatePrice(CmSvipPackage cmSvipPackage);
}
