package com.caimei365.manager.service.caimei.svip.impl;

import com.alibaba.fastjson.JSON;
import com.caimei365.manager.config.utils.UploadPicUtils;
import com.caimei365.manager.dao.svip.CmSvipHistoryDao;
import com.caimei365.manager.entity.caimei.svip.CmCoupon;
import com.caimei365.manager.entity.caimei.svip.CmCouponAssociate;
import com.caimei365.manager.entity.caimei.svip.NewCmShop;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2023/4/11
 */
@Service
public class CmCouponService {

    @Autowired
    private CmSvipHistoryDao historyDao;

    public CmCoupon cmCouponget(String id) {
        CmCoupon coupon = historyDao.CmCouponGet(id);
        setCouponStatus(coupon, new Date());
        if (coupon.getCouponType() == 3 && coupon.getShopId() != null) {
            //店铺券
            NewCmShop shop = historyDao.newCmShopGet(coupon.getShopId().toString());
            coupon.setShop(shop);
        }
        if ("1".equals(coupon.getCouponsMode())) {
            Integer codeNum = historyDao.findRedemptionCodeNum(coupon.getId());
            coupon.setCodeNum(codeNum);
        }
        return coupon;
    }

    public void save(CmCoupon cmCoupon) {
        if (StringUtils.isNotBlank(cmCoupon.getPcBanner())) {
            String image = UploadPicUtils.saveImageToServer(cmCoupon.getPcBanner());
            cmCoupon.setPcBanner(image);
        }
        if (StringUtils.isNotBlank(cmCoupon.getAppletsBanner())) {
            String image = UploadPicUtils.saveImageToServer(cmCoupon.getAppletsBanner());
            cmCoupon.setAppletsBanner(image);
        }
        Date date = new Date();
        cmCoupon.setCreateDate(date);
        setCouponStatus(cmCoupon, date);
        if (StringUtils.isBlank(cmCoupon.getCouponsMode())) {
            cmCoupon.setCouponsMode("0");
        }
        if (null == cmCoupon.getVipFlag()){
            cmCoupon.setVipFlag(0);
        }
        if(null==cmCoupon.getMoneyCouponFlag()){
            cmCoupon.setMoneyCouponFlag(2);
        }
        if (null == cmCoupon.getId()) {
            historyDao.insertCoupon(cmCoupon);
        } else {
            historyDao.updateCoupon(cmCoupon);
        }
        List<Integer> associateIds = historyDao.findByCouponId(cmCoupon.getId());
        if (0 == cmCoupon.getCouponType()) {
            //活动券
            if (StringUtils.isNotBlank(cmCoupon.getProductInfo())) {
                List<CmCouponAssociate> associateList = JSON.parseArray(cmCoupon.getProductInfo(), CmCouponAssociate.class);
                associateList.forEach(a -> {
                    if (a.getId() == null) {
                        a.setDelFlag("0");
                        a.setCouponId(Integer.valueOf(cmCoupon.getId()));
                        a.setAddTime(date);
                        historyDao.insertCouponAssociate(a);
                    } else {
                        associateIds.removeIf(id -> id.equals(a.getId()));
                        historyDao.updateCouponAssociate(a);
                    }
                });
            }
        }
        if (associateIds != null && associateIds.size() > 0) {
            associateIds.forEach(id -> {
                historyDao.logicDeleteCouponAssociate(id);
            });
        }
    }

    public void delete(CmCoupon cmCoupon) {
        historyDao.updateByDelFlag(cmCoupon.getId());
        historyDao.updateAssociateByDelFlag(cmCoupon.getId());
    }

    public void setCouponStatus(CmCoupon cmCoupon, Date date) {
        if (cmCoupon != null) {
            if (!cmCoupon.getStatus().contains("2")) {
                if (date.compareTo(cmCoupon.getStartDate()) < 0) {
                    cmCoupon.setStatus("0");
                } else if (date.compareTo(cmCoupon.getEndDate()) > 0) {
                    cmCoupon.setStatus("3");
                } else {
                    cmCoupon.setStatus("1");
                }
            } else {
                cmCoupon.setStatus("2");
            }
        }
    }
}
